unit EZStrStk;
  {-Example unit defining a stack for strings}

  {Note: the raison d'etre of this object definition is to show how
         easy it is to define an object based on one of EZSTRUCS
         object classes. And one that you don't have to continually
         remember to typecast the objects when you're adding or
         removing them from the container; all the nastiness is
         hidden!}

interface

uses
  Objects,
  EZStrucs;

type
  {A stack for storing strings}
  PStringStack = ^TStringStack;
  TStringStack = object
    Stack : TStack;

    constructor Init;
      {-Initialise the stack}
    destructor Done;
      {-Destroy the stack}

    function  Count : longint;
      {-Return the number of strings in the stack}
    function  IsEmpty : boolean;
      {-Return true if the stack is empty}
    function  Pop : string;
      {-Return the string on the top of the stack after popping it}
    function  Push(const S : string) : boolean;
      {-Return true if the string was pushed onto the stack}
  end;

implementation


{===TStringStack implementation======================================}
constructor TStringStack.Init;
  begin
    if not Stack.Init then
      Fail;
    Stack.SetDisposeData(EZStrDisposeData);
  end;
{--------}
destructor TStringStack.Done;
  begin
    Stack.Done;
  end;
{--------}
function TStringStack.Count : longint;
  begin
    Count := Stack.Count;
  end;
{--------}
function TStringStack.IsEmpty : boolean;
  begin
    IsEmpty := Stack.IsEmpty;
  end;
{--------}
function TStringStack.Pop : string;
  var
    PS : PString;
  begin
    Pop := '';
    if not IsEmpty then
      begin
        PS := PString(Stack.Pop);
        if Assigned(PS) then
          begin
            Pop := PS^;
            Stack.DisposeData(PS);
          end;
      end;
  end;
{--------}
function TStringStack.Push(const S : string) : boolean;
  var
    PS : PString;
    Pushed : boolean;
  begin
    Push := false;
    PS := NewStr(S);
    if Assigned(PS) then
      begin
        Pushed := Stack.Push(PS);
        if Pushed then
             Push := true
        else Stack.DisposeData(PS);
      end;
  end;
{====================================================================}

end.